#property copyright "Market Profile v2.1. 2009 Plus, plus@fxcoder.ru"
#property link      "http://www.fxcoder.ru"

#property indicator_chart_window

//  
extern int RangePeriod = PERIOD_D1;				//  ,     
extern int RangeCount = 20;						//  /
extern int Smooth = 10;							//   ,   2   + 1
int PointStep = 1;								//  
int DataPeriod = 1;								//   ,  -  
bool ShowHorizon = true;						//   

// 
extern color HGColor = C'160,192,224';			//  
extern color ModeColor = Blue;					//  
extern color MaxModeColor = CLR_NONE;			//  

int HGLineWidth = 1;							//   
double Zoom = 0;								//  , 0 - 

int ModeWidth = 1;								//  
int ModeStyle = STYLE_SOLID;					//  

// 
extern string Id = "+mp";						//   

int WaitSeconds = 1;							//  ,  ,  
int TickMethod = 1;								//   : 0 - Low >> High, 1 - Open > Low(High) > High(Low) > Close, 2 - HLC, 3 - HL
												// +4 -   , +8 -      .
int ModeMethod = 1;								//   : 0 -   , 1 -    , 2 -  1   

string onp;

datetime drawHistory[];		//  
datetime lastTime = 0;		//   
bool lastOK = false;


double hgPoint;				//   
int smooth = 0;
int hgLineWidth = 1;		//     


bool showHG, showModes, showMaxMode;


#include <+MPVL.mqh>

int init()
{
	onp = Id + "_" + RangePeriod;

	hgPoint = Point;
	
	bool is5digits = ((Digits == 3) || (Digits == 5)) && (MarketInfo(Symbol(), MODE_PROFITCALCMODE) == 0);
	
	if (PointStep == 0)
	{
		if (is5digits)
			hgPoint = Point * 10.0;
	}
	else
	{
		hgPoint = Point * PointStep;
	}


	smooth = Smooth * Point / hgPoint;
	int hgLineWidth = HGLineWidth;

	if (is5digits)
		smooth *= 10;
	else
		hgLineWidth = MathMax(HGLineWidth, 2);
		

	ArrayResize(drawHistory, 0);
	
	//  	
	showHG = (HGColor != CLR_NONE) && (HGColor != -16777216);
	showModes = (ModeColor != CLR_NONE) && (ModeColor != -16777216);
	showMaxMode = (MaxModeColor != CLR_NONE) && (MaxModeColor != -16777216);
}

int start()
{
	datetime currentTime = TimeLocal();

	//     ...
	if ((Volume[0] > 1) && lastOK)
	{
		// ...  ,     
		if (currentTime - lastTime < WaitSeconds)
			return(0);
	}

	lastTime = currentTime;


	if (ShowHorizon)
	{
		datetime hz = iTime(NULL, DataPeriod, iBars(NULL, DataPeriod) - 1);
	
		
		DrawVLine(onp + "hz", hz, Red, 1, STYLE_DOT, false);
		
	}

	double vh[], hLow;
	
	lastOK = true;
	for (int i = 0; i < RangeCount; i++)//1 - ShowLast
	{
		int barFrom, barTo, m1BarFrom, m1BarTo;

		datetime timeFrom = iTime(NULL, RangePeriod, i);

		datetime timeTo = Time[0];
		if (i != 0)
			timeTo = iTime(NULL, RangePeriod, i - 1);


		if (getRange(timeFrom, timeTo, barFrom, barTo, m1BarFrom, m1BarTo, DataPeriod))
		{
			if (!checkDrawHistory(timeFrom) || (i == 0))
			{
				int count = GetHGByRates(m1BarFrom, m1BarTo, TickMethod, vh, hLow, hgPoint, DataPeriod);
				
				if (count > 0)
				{
					if (i != 0)
						addDrawHistory(timeFrom);

					//  
					double zoom = Zoom*0.000001;
					if (zoom <= 0)
					{
						double maxVolume = vh[ArrayMaximum(vh)];
						zoom = (barFrom - barTo + 1) / maxVolume;
					}

					// 
					if (showHG)
					{
						string prefix = onp + "hg_" + TimeToStr(timeFrom) + "_";
						DrawHG(prefix, vh, hLow, barFrom, HGColor, HGColor, zoom, hgLineWidth, hgPoint);
					}
					
					if (showModes)
						drawModes(vh, hLow, barFrom, zoom, hgPoint);
				}
			}
		}
		else
		{
			lastOK = false;
		}
	}

	return(0);
}

int deinit()
{
	DeleteObjectsByPrefix(onp);
	return(0);
}

// ,      
bool checkDrawHistory(datetime time)
{
	int count = ArraySize(drawHistory);
	bool r = false;
	for (int i = 0; i < count; i++)
	{
		if (drawHistory[i] == time)
		{
			r = true;
			break;
		}
	}
	return(r);
}

//     
void addDrawHistory(datetime time)
{
	if (!checkDrawHistory(time))
	{
		int count = ArraySize(drawHistory);
		ArrayResize(drawHistory, count + 1);
		drawHistory[count] = time;
	}
}


//   
void drawModes(double& vh[], double hLow, int barFrom, double zoom, double point)
{
	int modes[], modeCount, j;
	double price;

	//  
	if (ModeMethod == 0)
		modeCount = GetModesIndexes1(vh, smooth, modes);
	else if (ModeMethod == 1)
		modeCount = GetModesIndexes2(vh, smooth, modes);
	else
		modeCount = GetModesIndexes3(vh, smooth, modes);

	// . 
	double max = 0;
	if (showMaxMode)
	{
		for (j = 0; j < modeCount; j++)
			if (vh[modes[j]] > max)
				max = vh[modes[j]];
	}

	for (j = 0; j < modeCount; j++)
	{
		double v = zoom*vh[modes[j]];

		//     (  ),    
		if (MathAbs(v) > 0)
		{
			price = hLow + modes[j]*point;
	
			datetime timeFrom = GetBarTime(barFrom);
			datetime timeTo = GetBarTime(barFrom - v);

			color cl = ModeColor;
			if (MathAbs(vh[modes[j]] - max) < point)
				cl = MaxModeColor;

			DrawTrend(onp + "mode_" + TimeToStr(timeFrom) + "_" + j, 
				timeFrom, price, timeTo, price, cl, ModeWidth, ModeStyle, false, false);
		}
	}
}



